;;;
;;;   LISP:    Rmtext.lsp
;;;   Version: 1.3
;;;   Copyright (C) 1994 by Cadd Software.
;;;   Date: 28 APR 94.
;;;
;;;   Permission to use, copy, modify, and distribute this software
;;;   for any purpose and without fee is hereby granted, provided
;;;   that the above copyright notice appears in all copies and that
;;;   both that copyright notice and this permission notice appear in
;;;   all supporting documentation.
;;;
;;;   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
;;;   WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
;;;   PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
;;;
;;;   Version 1.0 - initial release of Rmtext.lsp by Gary Kohan.
;;;                 this program will remove unwanted "spaces"
;;;                 that may inadvertantly creep into drawings...enjoy!
;;;
;;;           1.1 - program was removing "good" text - resolved!
;;;                 29 APR 94.
;;;
;;;           1.2 - added *error* and fixed huge ambiguous text counts!
;;;
;;;           1.3 - polished and tweeked!
;;;
;;;   Comments/criticism [72707,1412] or (703)-569-3459
;;;
;;;   DISCLAIMER AND LIMITS OF LIABILITY...
;;;
;;;          CADD Software makes no warranty of any kind, either
;;;     expressed or implied, including but not limited to implied
;;;     warranties of merchant ability and fitness for a particular
;;;     purpose, with respect to this software and any accompanying
;;;     documentation.
;;;
;;;          In no event shall CADD Software be liable for any
;;;     damages (including damages for loss of business profits,
;;;     business interruptions, loss of business information or
;;;     other pecuniary loss) arising out of the use of or in-
;;;     ability to use this software, even if CADD Software has
;;;     been advised of the possibility of such damages.

(defun C:RMTEXT (/ LOGO RMTEXT RM_ERR)

  (defun RM_ERR (s)

    (if (/= s "Function cancelled")
      (princ (strcat "\nError: " s))
    )
    (setq *error* old_err)
    (princ) );;defun rm_err

  (defun LOGO (fname  version)
      (print)
      (princ (strcat "\r"  fname "(c) 1994, Version "  version   ", by Cadd Software."
                     "\nUSAGE::Command:" fname  "<cr>"))
      (getstring "\n<any key>...")
      (print) );;LOGO

  (defun RMTEXT (/ ans ERASEM DXF ++ STRIPEM ERADICATE)
    (defun DXF (code data) (cdr (assoc code data)) )
    (defun ++  (s)(set s (1+ (eval s))) )
    (defun ERADICATE (pass)(++ 'CntErased)(command "._ERASE" en "")
     (if pass
       (princ (strcat "\rEradicating " (itoa CntErased) ))) )

    (defun  STRIPEM (text / cnt OK)
       (setq OK T  cnt 0)
       (cond ( (=  (setq len (strlen text))  1)  OK)
               (T
                   (setq len (+ 1 len))
                   (while (and OK  (<  (++ 'cnt) len) )
                     (if (/=  (ascii (substr text cnt 1))   32)
                       (setq OK nil)
                     );;if
                   );while
                  OK
       ));;condx2
     );STRIPEM

    (defun ERASEM (/ ss ed en etmax text cnt CntErased msg1 pass)

     (setq msg1 "\n0 ambiguous text entitie(s) found...no action.")

     (princ "\nWorking...")
     (cond ( (setq ss (ssget  "X"   '((0  . "TEXT")) ))
             (setq etmax (fix  (sslength ss))
                   pass  (if (> etmax 9999) T)
                   cnt -1
                   CntErased 0)

             (princ  (strcat "\r" (itoa etmax) " text entitie(s) found..."))
             (if pass (print))

             (while (/=  (setq etmax (1- etmax))  -1)
                (setq en (ssname ss (++ 'cnt))
                      ed (entget en)
                    text (dxf 1 ed))

                (cond ( (= (ascii text)  0) ;;0="
                        (ERADICATE pass) )
                      ( (AND (= (ascii text) 32)(STRIPEM text) );;32=" "
                        (ERADICATE pass) )
                      (T nil
                ));;condx2
             );while

             (princ
               (if (NOT (zerop CntErased))
                 (strcat "\n" (itoa CntErased) " ambiguous text entitie(s) removed." )
                 msg1
             ));;princ,strcat
            );;condx1

          (t (princ msg1)
     ));;condx2
    );;ERASEM


  (if (OR  (= "" (setq ans (strcase (getstring
    "\nThis program will remove ambiguous text entitie(s)...proceed, <Y>es/No:"))))
           (= ans "Y") )
    (ERASEM)
    (princ "\naborted!"))
  );;defun erasem

  ;; MAIN PROGRAM BEGINS
  (setq old_err *error*
        *error* RM_ERR)
  (setvar "cmdecho" 0)
  (LOGO  "RmText" "V1.3")
  (princ)

(RMTEXT)(princ));;defun C:RMTEXT
(setvar "cmdecho" 0)
